Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 3550)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 3551)
@@ -2566,18 +2715,19 @@
                                        * ( ibit21 + ibit22 + ibit23 )         &
                 - ( v(k,j,i)     + v(k,j-1,i) )                               &
-                                       * ( IBITS(advc_flags_1(k,j-1,i),21,1)  &
-                                         + IBITS(advc_flags_1(k,j-1,i),22,1)  &
-                                         + IBITS(advc_flags_1(k,j-1,i),23,1)  &
+                                       * (                                    &
+                        REAL( IBITS(advc_flags_1(k,j-1,i),21,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_1(k,j-1,i),22,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_1(k,j-1,i),23,1), KIND = wp )  &
                                          )                                    &
                   ) * ddy                                                     &
                +  ( w_comp(k)   * rho_air_zw(k) * ( ibit24 + ibit25 + ibit26 )&
                 -   w_comp(k-1) * rho_air_zw(k-1)                             &
-                                       * ( IBITS(advc_flags_1(k-1,j,i),24,1)  &
-                                         + IBITS(advc_flags_1(k-1,j,i),25,1)  &
-                                         + IBITS(advc_flags_1(k-1,j,i),26,1)  &
+                                       * (                                    &
+                        REAL( IBITS(advc_flags_1(k-1,j,i),24,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_1(k-1,j,i),25,1), KIND = wp )  &
+                      + REAL( IBITS(advc_flags_1(k-1,j,i),26,1), KIND = wp )  &
                                          )                                    &
                    ) * drho_air(k) * ddzw(k)                                  &
                 ) * 0.5_wp
-
 
           tend(k,j,i) = tend(k,j,i) - (                                       &
@@ -2595,5 +2745,4 @@
            flux_s_v(k,tn)   = flux_n(k)
            diss_s_v(k,tn)   = diss_n(k)
-
 !
 !--        Statistical Evaluation of v'v'. The factor has to be applied for
@@ -2619,124 +2768,4 @@
 
        ENDDO
-
-       DO  k = nzb_max+1, nzt
-
-          u_comp(k) = u(k,j-1,i+1) + u(k,j,i+1) - gu
-          flux_r(k) = u_comp(k) * (                                           &
-                      37.0_wp * ( v(k,j,i+1) + v(k,j,i)   )                   &
-                    -  8.0_wp * ( v(k,j,i+2) + v(k,j,i-1) )                   &
-                    +           ( v(k,j,i+3) + v(k,j,i-2) ) ) * adv_mom_5
-
-          diss_r(k) = - ABS( u_comp(k) ) * (                                  &
-                      10.0_wp * ( v(k,j,i+1) - v(k,j,i) )                     &
-                    -  5.0_wp * ( v(k,j,i+2) - v(k,j,i-1) )                   &
-                    +           ( v(k,j,i+3) - v(k,j,i-2) ) ) * adv_mom_5
-
-
-          v_comp(k) = v(k,j+1,i) + v(k,j,i)
-          flux_n(k) = ( v_comp(k) - gv ) * (                                  &
-                      37.0_wp * ( v(k,j+1,i) + v(k,j,i)   )                   &
-                    -  8.0_wp * ( v(k,j+2,i) + v(k,j-1,i) )                   &
-                      +         ( v(k,j+3,i) + v(k,j-2,i) ) ) * adv_mom_5
-
-          diss_n(k) = - ABS( v_comp(k) - gv ) * (                             &
-                      10.0_wp * ( v(k,j+1,i) - v(k,j,i)   )                   &
-                    -  5.0_wp * ( v(k,j+2,i) - v(k,j-1,i) )                   &
-                    +           ( v(k,j+3,i) - v(k,j-2,i) ) ) * adv_mom_5
-!
-!--       k index has to be modified near bottom and top, else array
-!--       subscripts will be exceeded.
-          ibit26 = IBITS(advc_flags_1(k,j,i),26,1)
-          ibit25 = IBITS(advc_flags_1(k,j,i),25,1)
-          ibit24 = IBITS(advc_flags_1(k,j,i),24,1)
-
-          k_ppp = k + 3 * ibit26
-          k_pp  = k + 2 * ( 1 - ibit24  )
-          k_mm  = k - 2 * ibit26
-
-          w_comp(k) = w(k,j-1,i) + w(k,j,i)
-          flux_t(k) = w_comp(k) * rho_air_zw(k) * (                           &
-                     ( 37.0_wp * ibit26 * adv_mom_5                           &
-                  +     7.0_wp * ibit25 * adv_mom_3                           &
-                  +              ibit24 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( v(k+1,j,i)   + v(k,j,i)    )                &
-              -      (  8.0_wp * ibit26 * adv_mom_5                           &
-                  +              ibit25 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( v(k_pp,j,i)  + v(k-1,j,i)  )                &
-              +      (           ibit26 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( v(k_ppp,j,i) + v(k_mm,j,i) )                &
-                                                  )
-
-          diss_t(k) = - ABS( w_comp(k) ) * rho_air_zw(k) * (                  &
-                     ( 10.0_wp * ibit26 * adv_mom_5                           &
-                  +     3.0_wp * ibit25 * adv_mom_3                           &
-                  +              ibit24 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( v(k+1,j,i)   - v(k,j,i)    )                &
-              -      (  5.0_wp * ibit26 * adv_mom_5                           &
-                  +              ibit25 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( v(k_pp,j,i)  - v(k-1,j,i)  )                &
-              +      (           ibit26 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( v(k_ppp,j,i) - v(k_mm,j,i) )                &
-                                                           )
-       ENDDO
-
-       DO  k = nzb_max+1, nzt
-
-          flux_d    = flux_t(k-1)
-          diss_d    = diss_t(k-1)
-!
-!--       Calculate the divergence of the velocity field. A respective
-!--       correction is needed to overcome numerical instabilities introduced
-!--       by a not sufficient reduction of divergences near topography.
-          div = ( ( u_comp(k) + gu - ( u(k,j-1,i)   + u(k,j,i)   ) ) * ddx    &
-               +  ( v_comp(k)      - ( v(k,j,i)     + v(k,j-1,i) ) ) * ddy    &
-               +  ( w_comp(k)   * rho_air_zw(k)   -                           &
-                    w_comp(k-1) * rho_air_zw(k-1)                             &
-                  ) * drho_air(k) * ddzw(k)                                   &
-                ) * 0.5_wp
-
-          tend(k,j,i) = tend(k,j,i) - (                                       &
-                         ( flux_r(k) + diss_r(k)                              &
-                       -   flux_l_v(k,j,tn) - diss_l_v(k,j,tn)   ) * ddx      &
-                       + ( flux_n(k) + diss_n(k)                              &
-                       -   flux_s_v(k,tn) - diss_s_v(k,tn)       ) * ddy      &
-                       + ( ( flux_t(k) + diss_t(k) )                          &
-                       -   ( flux_d    + diss_d    )                          &
-                                                   ) * drho_air(k) * ddzw(k)  &
-                                      ) + v(k,j,i) * div
-
-           flux_l_v(k,j,tn) = flux_r(k)
-           diss_l_v(k,j,tn) = diss_r(k)
-           flux_s_v(k,tn)   = flux_n(k)
-           diss_s_v(k,tn)   = diss_n(k)
-!
-!--        Statistical Evaluation of v'v'. The factor has to be applied for
-!--        right evaluation when gallilei_trans = .T. .
-           sums_vs2_ws_l(k,tn) = sums_vs2_ws_l(k,tn)                           &
-                + ( flux_n(k)                                                  &
-                    * ( v_comp(k) - 2.0_wp * hom(k,1,2,0)                   )  &
-                    / ( v_comp(k) - gv + SIGN( 1.0E-20_wp, v_comp(k) - gv ) )  &
-                  + diss_n(k)                                                  &
-                    *   ABS( v_comp(k) - 2.0_wp * hom(k,1,2,0)              )  &
-                    / ( ABS( v_comp(k) - gv ) + 1.0E-20_wp                  )  &
-                  ) *   weight_substep(intermediate_timestep_count)
-!
-!--        Statistical Evaluation of w'u'.
-           sums_wsvs_ws_l(k,tn) = sums_wsvs_ws_l(k,tn)                         &
-                + ( flux_t(k)                                                  &
-                    * ( w_comp(k) - 2.0_wp * hom(k,1,3,0)                   )  &
-                    / ( w_comp(k) + SIGN( 1.0E-20_wp, w_comp(k) )           )  &
-                  + diss_t(k)                                                  &
-                    *   ABS( w_comp(k) - 2.0_wp * hom(k,1,3,0)              )  &
-                    / ( ABS( w_comp(k) ) + 1.0E-20_wp                       )  &
-                  ) *   weight_substep(intermediate_timestep_count)
-
-       ENDDO
        sums_vs2_ws_l(nzb,tn) = sums_vs2_ws_l(nzb+1,tn)
 
@@ -2774,13 +2803,4 @@
 
        INTEGER(iwp) ::  i      !< grid index along x-direction
-       INTEGER(iwp) ::  ibit27 !< flag indicating 1st-order scheme along x-direction
-       INTEGER(iwp) ::  ibit28 !< flag indicating 3rd-order scheme along x-direction
-       INTEGER(iwp) ::  ibit29 !< flag indicating 5th-order scheme along x-direction
-       INTEGER(iwp) ::  ibit30 !< flag indicating 1st-order scheme along y-direction
-       INTEGER(iwp) ::  ibit31 !< flag indicating 3rd-order scheme along y-direction
-       INTEGER(iwp) ::  ibit32 !< flag indicating 5th-order scheme along y-direction
-       INTEGER(iwp) ::  ibit33 !< flag indicating 1st-order scheme along z-direction
-       INTEGER(iwp) ::  ibit34 !< flag indicating 3rd-order scheme along z-direction
-       INTEGER(iwp) ::  ibit35 !< flag indicating 5th-order scheme along z-direction
        INTEGER(iwp) ::  i_omp  !< leftmost index on subdomain, or in case of OpenMP, on thread
        INTEGER(iwp) ::  j      !< grid index along y-direction
@@ -2791,4 +2811,13 @@
        INTEGER(iwp) ::  tn     !< number of OpenMP thread
        
+       REAL(wp)    ::  ibit27  !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit28  !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit29  !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)    ::  ibit30  !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit31  !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit32  !< flag indicating 5th-order scheme along y-direction
+       REAL(wp)    ::  ibit33  !< flag indicating 1st-order scheme along z-direction
+       REAL(wp)    ::  ibit34  !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)    ::  ibit35  !< flag indicating 5th-order scheme along z-direction
        REAL(wp)    ::  diss_d  !< discretized artificial dissipation at top of the grid box
        REAL(wp)    ::  div     !< divergence on w-grid
@@ -2815,7 +2844,7 @@
 
           DO  k = nzb+1, nzb_max
-             ibit32 = IBITS(advc_flags_2(k,j-1,i),0,1)
-             ibit31 = IBITS(advc_flags_1(k,j-1,i),31,1)
-             ibit30 = IBITS(advc_flags_1(k,j-1,i),30,1)
+             ibit32 = REAL( IBITS(advc_flags_2(k,j-1,i),0,1),  KIND = wp )
+             ibit31 = REAL( IBITS(advc_flags_1(k,j-1,i),31,1), KIND = wp )
+             ibit30 = REAL( IBITS(advc_flags_1(k,j-1,i),30,1), KIND = wp )
 
              v_comp(k)      = v(k+1,j,i) + v(k,j,i) - gv
@@ -2859,5 +2888,5 @@
                          -  8.0_wp * ( w(k,j+1,i) +w(k,j-2,i)  )              &
                          +           ( w(k,j+2,i) + w(k,j-3,i) ) ) * adv_mom_5
-             diss_s_w(k,tn) = - ABS( v_comp(k) ) * (                         &
+             diss_s_w(k,tn) = - ABS( v_comp(k) ) * (                          &
                            10.0_wp * ( w(k,j,i) - w(k,j-1,i)   )              &
                          -  5.0_wp * ( w(k,j+1,i) - w(k,j-2,i) )              &
@@ -2873,7 +2902,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit29 = IBITS(advc_flags_1(k,j,i-1),29,1)
-             ibit28 = IBITS(advc_flags_1(k,j,i-1),28,1)
-             ibit27 = IBITS(advc_flags_1(k,j,i-1),27,1)
+             ibit29 = REAL( IBITS(advc_flags_1(k,j,i-1),29,1), KIND = wp )
+             ibit28 = REAL( IBITS(advc_flags_1(k,j,i-1),28,1), KIND = wp )
+             ibit27 = REAL( IBITS(advc_flags_1(k,j,i-1),27,1), KIND = wp )
 
              u_comp(k)        = u(k+1,j,i) + u(k,j,i) - gu
@@ -2926,5 +2955,111 @@
        ENDIF
 !
-!--    The lower flux has to be calculated explicetely for the tendency at
+!--    Now compute the fluxes and tendency terms for the horizontal
+!--    and vertical parts.
+       DO  k = nzb+1, nzb_max
+
+          ibit29 = REAL( IBITS(advc_flags_1(k,j,i),29,1), KIND = wp )
+          ibit28 = REAL( IBITS(advc_flags_1(k,j,i),28,1), KIND = wp )
+          ibit27 = REAL( IBITS(advc_flags_1(k,j,i),27,1), KIND = wp )
+
+          u_comp(k) = u(k+1,j,i+1) + u(k,j,i+1) - gu
+          flux_r(k) = u_comp(k) * (                                           &
+                     ( 37.0_wp * ibit29 * adv_mom_5                           &
+                  +     7.0_wp * ibit28 * adv_mom_3                           &
+                  +              ibit27 * adv_mom_1                           &
+                     ) *                                                      &
+                                    ( w(k,j,i+1) + w(k,j,i)   )               &
+              -      (  8.0_wp * ibit29 * adv_mom_5                           &
+                  +              ibit28 * adv_mom_3                           &
+                     ) *                                                      &
+                                    ( w(k,j,i+2) + w(k,j,i-1) )               &
+              +      (           ibit29 * adv_mom_5                           &
+                     ) *                                                      &
+                                    ( w(k,j,i+3) + w(k,j,i-2) )               &
+                                  )
+
+          diss_r(k) = - ABS( u_comp(k) ) * (                                  &
+                     ( 10.0_wp * ibit29 * adv_mom_5                           &
+                  +     3.0_wp * ibit28 * adv_mom_3                           &
+                  +              ibit27 * adv_mom_1                           &
+                     ) *                                                      &
+                                    ( w(k,j,i+1) - w(k,j,i)   )               &
+              -      (  5.0_wp * ibit29 * adv_mom_5                           &
+                  +              ibit28 * adv_mom_3                           &
+                     ) *                                                      &
+                                    ( w(k,j,i+2) - w(k,j,i-1) )               &
+              +      (           ibit29 * adv_mom_5                           &
+                     ) *                                                      &
+                                    ( w(k,j,i+3) - w(k,j,i-2) )               &
+                                           )
+
+          ibit32 = REAL( IBITS(advc_flags_2(k,j,i),0,1),  KIND = wp )
+          ibit31 = REAL( IBITS(advc_flags_1(k,j,i),31,1), KIND = wp )
+          ibit30 = REAL( IBITS(advc_flags_1(k,j,i),30,1), KIND = wp )
+
+          v_comp(k) = v(k+1,j+1,i) + v(k,j+1,i) - gv
+          flux_n(k) = v_comp(k) * (                                           &
+                     ( 37.0_wp * ibit32 * adv_mom_5                           &
+                  +     7.0_wp * ibit31 * adv_mom_3                           &
+                  +              ibit30 * adv_mom_1                           &
+                     ) *                                                      &
+                                    ( w(k,j+1,i) + w(k,j,i)   )               &
+              -      (  8.0_wp * ibit32 * adv_mom_5                           &
+                  +              ibit31 * adv_mom_3                           &
+                     ) *                                                      &
+                                    ( w(k,j+2,i) + w(k,j-1,i) )               &
+              +      (           ibit32 * adv_mom_5                           &
+                     ) *                                                      &
+                                    ( w(k,j+3,i) + w(k,j-2,i) )               &
+                                  )
+
+          diss_n(k) = - ABS( v_comp(k) ) * (                                  &
+                     ( 10.0_wp * ibit32 * adv_mom_5                           &
+                  +     3.0_wp * ibit31 * adv_mom_3                           &
+                  +              ibit30 * adv_mom_1                           &
+                     ) *                                                      &
+                                    ( w(k,j+1,i) - w(k,j,i)  )                &
+              -      (  5.0_wp * ibit32 * adv_mom_5                           &
+                  +              ibit31 * adv_mom_3                           &
+                     ) *                                                      &
+                                   ( w(k,j+2,i) - w(k,j-1,i) )                &
+              +      (           ibit32 * adv_mom_5                           &
+                     ) *                                                      &
+                                   ( w(k,j+3,i) - w(k,j-2,i) )                &
+                                           )
+       ENDDO
+
+       DO  k = nzb_max+1, nzt
+
+          u_comp(k) = u(k+1,j,i+1) + u(k,j,i+1) - gu
+          flux_r(k) = u_comp(k) * (                                           &
+                      37.0_wp * ( w(k,j,i+1) + w(k,j,i)   )                   &
+                    -  8.0_wp * ( w(k,j,i+2) + w(k,j,i-1) )                   &
+                    +           ( w(k,j,i+3) + w(k,j,i-2) ) ) * adv_mom_5
+
+          diss_r(k) = - ABS( u_comp(k) ) * (                                  &
+                      10.0_wp * ( w(k,j,i+1) - w(k,j,i)   )                   &
+                    -  5.0_wp * ( w(k,j,i+2) - w(k,j,i-1) )                   &
+                    +           ( w(k,j,i+3) - w(k,j,i-2) ) ) * adv_mom_5
+
+          v_comp(k) = v(k+1,j+1,i) + v(k,j+1,i) - gv
+          flux_n(k) = v_comp(k) * (                                           &
+                      37.0_wp * ( w(k,j+1,i) + w(k,j,i)   )                   &
+                    -  8.0_wp * ( w(k,j+2,i) + w(k,j-1,i) )                   &
+                    +           ( w(k,j+3,i) + w(k,j-2,i) ) ) * adv_mom_5
+
+          diss_n(k) = - ABS( v_comp(k) ) * (                                  &
+                      10.0_wp * ( w(k,j+1,i) - w(k,j,i)   )                   &
+                    -  5.0_wp * ( w(k,j+2,i) - w(k,j-1,i) )                   &
+                    +           ( w(k,j+3,i) - w(k,j-2,i) ) ) * adv_mom_5
+       ENDDO
+
+!
+!--    Now, compute vertical fluxes. Split loop into a part treating the 
+!--    lowest 2 grid points with indirect indexing, a main loop without
+!--    indirect indexing, and a loop for the uppermost 2 grip points with
+!--    indirect indexing. This allows better vectorization for the main loop.
+!--    First, compute the flux at model surface, which need has to be 
+!--    calculated explicetely for the tendency at
 !--    the first w-level. For topography wall this is done implicitely by
 !--    advc_flags_1.
@@ -2933,84 +3068,12 @@
        flux_t(0) = w_comp(k)       * ( w(k,j,i) + w(k-1,j,i) ) * adv_mom_1
        diss_t(0) = -ABS(w_comp(k)) * ( w(k,j,i) - w(k-1,j,i) ) * adv_mom_1
-!
-!--    Now compute the fluxes and tendency terms for the horizontal
-!--    and vertical parts.
-       DO  k = nzb+1, nzb_max
-
-          ibit29 = IBITS(advc_flags_1(k,j,i),29,1)
-          ibit28 = IBITS(advc_flags_1(k,j,i),28,1)
-          ibit27 = IBITS(advc_flags_1(k,j,i),27,1)
-
-          u_comp(k) = u(k+1,j,i+1) + u(k,j,i+1) - gu
-          flux_r(k) = u_comp(k) * (                                           &
-                     ( 37.0_wp * ibit29 * adv_mom_5                           &
-                  +     7.0_wp * ibit28 * adv_mom_3                           &
-                  +              ibit27 * adv_mom_1                           &
-                     ) *                                                      &
-                                    ( w(k,j,i+1) + w(k,j,i)   )               &
-              -      (  8.0_wp * ibit29 * adv_mom_5                           &
-                  +              ibit28 * adv_mom_3                           &
-                     ) *                                                      &
-                                    ( w(k,j,i+2) + w(k,j,i-1) )               &
-              +      (           ibit29 * adv_mom_5                           &
-                     ) *                                                      &
-                                    ( w(k,j,i+3) + w(k,j,i-2) )               &
-                                  )
-
-          diss_r(k) = - ABS( u_comp(k) ) * (                                  &
-                     ( 10.0_wp * ibit29 * adv_mom_5                           &
-                  +     3.0_wp * ibit28 * adv_mom_3                           &
-                  +              ibit27 * adv_mom_1                           &
-                     ) *                                                      &
-                                    ( w(k,j,i+1) - w(k,j,i)   )               &
-              -      (  5.0_wp * ibit29 * adv_mom_5                           &
-                  +              ibit28 * adv_mom_3                           &
-                     ) *                                                      &
-                                    ( w(k,j,i+2) - w(k,j,i-1) )               &
-              +      (           ibit29 * adv_mom_5                           &
-                     ) *                                                      &
-                                    ( w(k,j,i+3) - w(k,j,i-2) )               &
-                                           )
-
-          ibit32 = IBITS(advc_flags_2(k,j,i),0,1)
-          ibit31 = IBITS(advc_flags_1(k,j,i),31,1)
-          ibit30 = IBITS(advc_flags_1(k,j,i),30,1)
-
-          v_comp(k) = v(k+1,j+1,i) + v(k,j+1,i) - gv
-          flux_n(k) = v_comp(k) * (                                           &
-                     ( 37.0_wp * ibit32 * adv_mom_5                           &
-                  +     7.0_wp * ibit31 * adv_mom_3                           &
-                  +              ibit30 * adv_mom_1                           &
-                     ) *                                                      &
-                                    ( w(k,j+1,i) + w(k,j,i)   )               &
-              -      (  8.0_wp * ibit32 * adv_mom_5                           &
-                  +              ibit31 * adv_mom_3                           &
-                     ) *                                                      &
-                                    ( w(k,j+2,i) + w(k,j-1,i) )               &
-              +      (           ibit32 * adv_mom_5                           &
-                     ) *                                                      &
-                                    ( w(k,j+3,i) + w(k,j-2,i) )               &
-                                  )
-
-          diss_n(k) = - ABS( v_comp(k) ) * (                                  &
-                     ( 10.0_wp * ibit32 * adv_mom_5                           &
-                  +     3.0_wp * ibit31 * adv_mom_3                           &
-                  +              ibit30 * adv_mom_1                           &
-                     ) *                                                      &
-                                    ( w(k,j+1,i) - w(k,j,i)  )                &
-              -      (  5.0_wp * ibit32 * adv_mom_5                           &
-                  +              ibit31 * adv_mom_3                           &
-                     ) *                                                      &
-                                   ( w(k,j+2,i) - w(k,j-1,i) )                &
-              +      (           ibit32 * adv_mom_5                           &
-                     ) *                                                      &
-                                   ( w(k,j+3,i) - w(k,j-2,i) )                &
-                                           )
+       
+       DO  k = nzb+1, nzb+2
 !
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit35 = IBITS(advc_flags_2(k,j,i),3,1)
-          ibit34 = IBITS(advc_flags_2(k,j,i),2,1)
-          ibit33 = IBITS(advc_flags_2(k,j,i),1,1)
+          ibit35 = REAL( IBITS(advc_flags_2(k,j,i),3,1), KIND = wp )
+          ibit34 = REAL( IBITS(advc_flags_2(k,j,i),2,1), KIND = wp )
+          ibit33 = REAL( IBITS(advc_flags_2(k,j,i),1,1), KIND = wp )
 
           k_ppp = k + 3 * ibit35
@@ -3049,6 +3112,88 @@
                                                           )
        ENDDO
-
-       DO  k = nzb+1, nzb_max
+       
+       DO  k = nzb+3, nzt-2
+       
+          ibit35 = REAL( IBITS(advc_flags_2(k,j,i),3,1), KIND = wp )
+          ibit34 = REAL( IBITS(advc_flags_2(k,j,i),2,1), KIND = wp )
+          ibit33 = REAL( IBITS(advc_flags_2(k,j,i),1,1), KIND = wp )
+
+          w_comp(k) = w(k+1,j,i) + w(k,j,i)
+          flux_t(k) = w_comp(k) * rho_air(k+1) * (                            &
+                     ( 37.0_wp * ibit35 * adv_mom_5                           &
+                  +     7.0_wp * ibit34 * adv_mom_3                           &
+                  +              ibit33 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( w(k+1,j,i)  + w(k,j,i)     )                &
+              -      (  8.0_wp * ibit35 * adv_mom_5                           &
+                  +              ibit34 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( w(k+2,j,i)  + w(k-1,j,i)  )                 &
+              +      (           ibit35 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( w(k+3,j,i) + w(k-2,j,i) )                   &
+                                                 )
+
+          diss_t(k) = - ABS( w_comp(k) ) * rho_air(k+1) * (                   &
+                     ( 10.0_wp * ibit35 * adv_mom_5                           &
+                  +     3.0_wp * ibit34 * adv_mom_3                           &
+                  +              ibit33 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( w(k+1,j,i)   - w(k,j,i)    )                &
+              -      (  5.0_wp * ibit35 * adv_mom_5                           &
+                  +              ibit34 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( w(k+2,j,i)  - w(k-1,j,i)  )                 &
+              +      (           ibit35 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( w(k+3,j,i) - w(k-2,j,i) )                   &
+                                                          )
+       ENDDO
+       
+       DO  k = nzt-1, nzt
+!
+!--       k index has to be modified near bottom and top, else array
+!--       subscripts will be exceeded.
+          ibit35 = REAL( IBITS(advc_flags_2(k,j,i),3,1), KIND = wp )
+          ibit34 = REAL( IBITS(advc_flags_2(k,j,i),2,1), KIND = wp )
+          ibit33 = REAL( IBITS(advc_flags_2(k,j,i),1,1), KIND = wp )
+
+          k_ppp = k + 3 * ibit35
+          k_pp  = k + 2 * ( 1 - ibit33  )
+          k_mm  = k - 2 * ibit35
+
+          w_comp(k) = w(k+1,j,i) + w(k,j,i)
+          flux_t(k) = w_comp(k) * rho_air(k+1) * (                            &
+                     ( 37.0_wp * ibit35 * adv_mom_5                           &
+                  +     7.0_wp * ibit34 * adv_mom_3                           &
+                  +              ibit33 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( w(k+1,j,i)  + w(k,j,i)     )                &
+              -      (  8.0_wp * ibit35 * adv_mom_5                           &
+                  +              ibit34 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( w(k_pp,j,i)  + w(k-1,j,i)  )                &
+              +      (           ibit35 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( w(k_ppp,j,i) + w(k_mm,j,i) )                &
+                                                 )
+
+          diss_t(k) = - ABS( w_comp(k) ) * rho_air(k+1) * (                   &
+                     ( 10.0_wp * ibit35 * adv_mom_5                           &
+                  +     3.0_wp * ibit34 * adv_mom_3                           &
+                  +              ibit33 * adv_mom_1                           &
+                     ) *                                                      &
+                                ( w(k+1,j,i)   - w(k,j,i)    )                &
+              -      (  5.0_wp * ibit35 * adv_mom_5                           &
+                  +              ibit34 * adv_mom_3                           &
+                     ) *                                                      &
+                                ( w(k_pp,j,i)  - w(k-1,j,i)  )                &
+              +      (           ibit35 * adv_mom_5                           &
+                     ) *                                                      &
+                                ( w(k_ppp,j,i) - w(k_mm,j,i) )                &
+                                                          )
+       ENDDO
+       
+       DO  k = nzb+1, nzt
 
           flux_d    = flux_t(k-1)
